module Quox.BoolExtra

import public Data.Bool


export infixr 5 `andM`
export infixr 4 `orM`

public export
andM, orM : Monad m => m Bool -> m Bool -> m Bool
andM a b = if     !a then b else pure False
orM  a b = if not !a then b else pure True
